# $Id$

# Define the kmod package name here.
%define kmod_name nilfs2
%define real_name nilfs2
%define version 1.1.1

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion:%define kversion 2.6.32-131.0.15.el6.%{_target_cpu}}

Summary: NILFS2 kernel module
Name: %{kmod_name}-kmod
Version: %{version}
Release: 4%{?dist}
License: GPL
Group: System Environment/Kernel
URL: http://www.nilfs.org/

# Sources.
Source0: %{kmod_name}-kmod-%{version}.tar.bz2
Source10: kmodtool-%{kmod_name}-el6

Patch10: nilfs2-kmod-1.1-build-for-rhel61ga.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)

ExclusiveArch: i686 x86_64
BuildRequires: redhat-rpm-config
BuildRequires: rpm-build
BuildRequires: gcc
BuildRequires: make
BuildRequires: binutils
BuildRequires: coreutils
BuildRequires: kernel-headers
BuildRequires: kernel-devel = %{expand:%(basename %{kversion} .%{_target_cpu} 2>/dev/null)}

Obsoletes: kmod-nilfs2 <= %{version}-%{release}

# Magic hidden here.
%define kmodtool sh %{SOURCE10}
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kversion} "" 2>/dev/null)}

# Disable the building of the debug package(s).
%define	debug_package %{nil}

%description
NILFS2 is a log-structured file system for Linux.

%prep
%setup -q -n %{real_name}-%{version}
%patch10 -p1

%{__cat} <<EOF >kmod-%{kmod_name}.conf
override %{kmod_name} * weak-updates/%{kmod_name}
EOF

%build
ksrc="%{_usrsrc}/kernels/%{kversion}"
%{__make} %{?_smp_mflags} -C "$ksrc" SUBDIRS=$PWD/fs/nilfs2 BUILD_DIR=$PWD/fs/nilfs2 NOSTDINC_FLAGS=-I$PWD/include modules

%install
%{__rm} -rf %{buildroot}
export INSTALL_MOD_PATH="%{buildroot}"
export INSTALL_MOD_DIR="extra/%{kmod_name}"
ksrc="%{_usrsrc}/kernels/%{kversion}"
%{__make} -C "$ksrc" modules_install M="$PWD/fs/nilfs2"
%{__install} -Dp -m0644 kmod-%{kmod_name}.conf %{buildroot}/etc/depmod.d/kmod-%{kmod_name}.conf
# Strip the module(s).
find %{buildroot} -type f -name \*.ko -exec %{__strip} --strip-debug \{\} \;
# Remove the files that are not required.
%{__rm} -f %{buildroot}/lib/modules/%{kversion}/modules.*

for file in ChangeLog COPYING README; do
    %{__install} -Dp -m0644 $file %{buildroot}%{_docdir}/kmod-%{kmod_name}-%{version}/$file
done

%clean
%{__rm} -rf %{buildroot}

%changelog
* Tue Apr 27 2014 Seiji Kihara <kihara@osrg.net> 1.1-4
- modified patch to build for RHEL 6 kernels.

* Tue Apr 27 2014 Seiji Kihara <kihara@osrg.net> 0.6.0-3
- modified patch to build for the RHEL 6.1 GA kernel.
- added HAVE_MNT_DROP_WRITE to kern_feature.h for kernels older than RHEL 6.4.

* Tue Jun 11 2013 Seiji Kihara <kihara@osrg.net> 0.4.5-2
- added patch to build for the RHEL 6.1 GA kernel.

* Wed Nov 30 2011 Seiji Kihara <kihara@osrg.net> 0.3.0-1
- fixed preun part of kmodtool.  Thanks to Shingo TAKADA <takada@takezono2.tv>.
- added build dependencies.

* Wed Nov 23 2011 Seiji Kihara <kihara@osrg.net> 0.3.0-0
- Initial package for RHEL6.
